Subject: bug#54814: 29.0.50; symbol visibility in modules may cause emacs crash in nativ-compilation emacs

From: Eli Zaretskii <[email-masked]>
Date: Sat, 09 Apr 2022 19:23:53 +0300

> X-Spam-Status: No, score=-1 tagged_above=-999 required=6.2
> 	tests=[ALL_TRUSTED=-1] autolearn=disabled
> From: [email-masked]
> Cc: Andrea Corallo <[email-masked]>,  [email-masked]
> Date: Sat, 09 Apr 2022 18:18:10 +0200
> 
> Eli Zaretskii <[email-masked]> writes:
> 
> >> From: [email-masked]
> >> Date: Sat, 09 Apr 2022 15:09:48 +0200
> >> 
> >> 
> >> symbol visibility in modules may cause emacs crash in nativ-compilation
> >> emacs
> >
> > Does it really have to do anything with native-compilation?  The fixes
> > seem to be to compile the external modules with less visibility, but
> > that doesn't affect Emacs, only the modules.
> >
> > Or am I missing something?
> 
> Well, I'm not really sure, but I have a couple of different builds of
> emacs, and when I load the emacs-zmq precompiled binaries they crash my
> main emacs, which has native-compilation, but not the other emacs I
> tried this in. I also get the same result of crashing native emacs, when
> using the packaged build proceedure of emacs-zmq. The hidden-visibility
> branch seems to fix these problems.

It's possible that Emacs with native-compilation somehow triggers the
problem, but the proposed fixes are entirely in the modules, AFAICT.

> Can I help pinpointing the issue somehow?

A detailed explanation of why it crashes could help, I think.  All I
saw are backtraces with no details, and no explanation what exactly
caused the crash and how that was related to symbol visibility.